//Includes:
#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.3"


new g_killCount[MAXPLAYERS+1];

new Handle:bt_enable;
new Handle:bt_enableweapontracers;
new Handle:bt_timescale;
new Handle:bt_bomb_timescale;
new Handle:bt_trans;
new Handle:bt_fsound;
new Handle:bt_grenade;
new Handle:bt_c4;
new Handle:bt_kills;
new Handle:bt_kills_enabled;

new slowdown = 0;
new focussound = 2;
new transition = false;
new Float:timescale = 0.50;
new Float:bomb_timescale = 0.20;

new Handle:Cheats = INVALID_HANDLE;

static const String:Weapons[][]={"knife"};

new Handle:bt_enableweapon_usp;
new Handle:bt_enableweapon_glock;
new Handle:bt_enableweapon_deagle;
new Handle:bt_enableweapon_p228;
new Handle:bt_enableweapon_elite;
new Handle:bt_enableweapon_fiveseven;
new Handle:bt_enableweapon_m4a1;
new Handle:bt_enableweapon_ak47;
new Handle:bt_enableweapon_aug;
new Handle:bt_enableweapon_sg552;
new Handle:bt_enableweapon_galil;
new Handle:bt_enableweapon_famas;
new Handle:bt_enableweapon_scout;
new Handle:bt_enableweapon_sg550;
new Handle:bt_enableweapon_m249;
new Handle:bt_enableweapon_g3sg1;
new Handle:bt_enableweapon_ump45;
new Handle:bt_enableweapon_mp5navy;
new Handle:bt_enableweapon_m3;
new Handle:bt_enableweapon_xm1014;
new Handle:bt_enableweapon_tmp;
new Handle:bt_enableweapon_mac10;
new Handle:bt_enableweapon_p90;
new Handle:bt_enableweapon_awp;


new g_BeamSprite[20];

new Handle:g_CvarTeam2Red = INVALID_HANDLE;
new Handle:g_CvarTeam2Blue = INVALID_HANDLE;
new Handle:g_CvarTeam2Green = INVALID_HANDLE;
new Handle:g_CvarTeam3Red = INVALID_HANDLE;
new Handle:g_CvarTeam3Blue = INVALID_HANDLE;
new Handle:g_CvarTeam3Green = INVALID_HANDLE;
new Handle:g_CvarTrans = INVALID_HANDLE;

new Handle:g_CvarM249Life = INVALID_HANDLE;
new Handle:g_CvarM249Width = INVALID_HANDLE;

new Handle:g_CvarP90Life = INVALID_HANDLE;
new Handle:g_CvarP90Width = INVALID_HANDLE;

new Handle:g_CvarUSPLife = INVALID_HANDLE;
new Handle:g_CvarUSPWidth = INVALID_HANDLE;

new Handle:g_CvarGlockLife = INVALID_HANDLE;
new Handle:g_CvarGlockWidth = INVALID_HANDLE;

new Handle:g_CvarDeagleLife = INVALID_HANDLE;
new Handle:g_CvarDeagleWidth = INVALID_HANDLE;

new Handle:g_CvarXM1014Life = INVALID_HANDLE;
new Handle:g_CvarXM1014Width = INVALID_HANDLE;

new Handle:g_CvarM3Life = INVALID_HANDLE;
new Handle:g_CvarM3Width = INVALID_HANDLE;

new Handle:g_CvarP228Life = INVALID_HANDLE;
new Handle:g_CvarP228Width = INVALID_HANDLE;

new Handle:g_CvarMP5Life = INVALID_HANDLE;
new Handle:g_CvarMP5Width = INVALID_HANDLE;

new Handle:g_CvarUMP45Life = INVALID_HANDLE;
new Handle:g_CvarUMP45Width = INVALID_HANDLE;

new Handle:g_CvarAWPLife = INVALID_HANDLE;
new Handle:g_CvarAWPWidth = INVALID_HANDLE;

new Handle:g_CvarScoutLife = INVALID_HANDLE;
new Handle:g_CvarScoutWidth = INVALID_HANDLE;

new Handle:g_CvarSG550Life = INVALID_HANDLE;
new Handle:g_CvarSG550Width = INVALID_HANDLE;

new Handle:g_CvarG3sg1Life = INVALID_HANDLE;
new Handle:g_CvarG3sg1Width = INVALID_HANDLE;

new Handle:g_CvarTMPLife = INVALID_HANDLE;
new Handle:g_CvarTMPWidth = INVALID_HANDLE;

new Handle:g_CvarMAC10Life = INVALID_HANDLE;
new Handle:g_CvarMAC10Width = INVALID_HANDLE;

new Handle:g_CvarM4A1Life = INVALID_HANDLE;
new Handle:g_CvarM4A1Width = INVALID_HANDLE;

new Handle:g_CvarAK47Life = INVALID_HANDLE;
new Handle:g_CvarAK47Width = INVALID_HANDLE;

new Handle:g_CvarEliteLife = INVALID_HANDLE;
new Handle:g_CvarEliteWidth = INVALID_HANDLE;

new Handle:g_CvarFivesevenLife = INVALID_HANDLE;
new Handle:g_CvarFivesevenWidth = INVALID_HANDLE;

new Handle:g_CvarSG552Life = INVALID_HANDLE;
new Handle:g_CvarSG552Width = INVALID_HANDLE;

new Handle:g_CvarFamasLife = INVALID_HANDLE;
new Handle:g_CvarFamasWidth = INVALID_HANDLE;

new Handle:g_CvarAUGLife = INVALID_HANDLE;
new Handle:g_CvarAUGWidth = INVALID_HANDLE;

new Handle:g_CvarGalilLife = INVALID_HANDLE;
new Handle:g_CvarGalilWidth = INVALID_HANDLE;

public Plugin:myinfo = 

{
	name = "SM Bullet Time",
	author = "Andi67",
	description = "Creates a slow-motion effect on events in bullet time / matrix style",
	version = PLUGIN_VERSION,
	url = "http://www.dodsourceplugins.net/"
};

public OnPluginStart() 
{
	CreateConVar("sm_bullettime_version", PLUGIN_VERSION, "SM Bullet Time Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	bt_enable = CreateConVar("bt_enable", "1", "Enables/Disables Bullet Time.", FCVAR_PLUGIN);
	bt_enableweapontracers = CreateConVar("bt_enableweapontracers", "1", "Enables/Disables Bullet Time Tracers.", FCVAR_PLUGIN);
	bt_grenade = CreateConVar("bt_grenade", "1", "Starts bullet time on kill with handgrenade.", FCVAR_PLUGIN);
	bt_c4 = CreateConVar("bt_c4", "1", "Enables BT on bomb explodes.", FCVAR_PLUGIN);	
	bt_kills_enabled = CreateConVar("bt_kills_enabled", "1", "Enables bt_kills for weapons.", FCVAR_PLUGIN);	
	bt_kills = CreateConVar("bt_kills", "3", "Kills for enabling BT on weapons exept Knife/Grenade.", FCVAR_PLUGIN);	

	bt_enableweapon_usp = CreateConVar("bt_enableweapon_usp", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_glock = CreateConVar("bt_enableweapon_glock", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_deagle = CreateConVar("bt_enableweapon_deagle", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_p228 = CreateConVar("bt_enableweapon_p228", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_elite = CreateConVar("bt_enableweapon_elite", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_fiveseven = CreateConVar("bt_enableweapon_fiveseven", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_m4a1 = CreateConVar("bt_enableweapon_m4a1", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_ak47 = CreateConVar("bt_enableweapon_ak47", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_aug = CreateConVar("bt_enableweapon_aug", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_sg552 = CreateConVar("bt_enableweapon_sg552", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_galil = CreateConVar("bt_enableweapon_galil", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_famas = CreateConVar("bt_enableweapon_famas", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_scout = CreateConVar("bt_enableweapon_scout", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_sg550 = CreateConVar("bt_enableweapon_sg550", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_m249 = CreateConVar("bt_enableweapon_m249", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_g3sg1 = CreateConVar("bt_enableweapon_g3sg1", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_ump45 = CreateConVar("bt_enableweapon_ump45", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_mp5navy = CreateConVar("bt_enableweapon_mp5navy", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_m3 = CreateConVar("bt_enableweapon_m3", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_xm1014 = CreateConVar("bt_enableweapon_xm1014", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_tmp = CreateConVar("bt_enableweapon_tmp", "1", "Enables .", FCVAR_PLUGIN);
	bt_enableweapon_mac10 = CreateConVar("bt_enableweapon_mac10", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_p90 = CreateConVar("bt_enableweapon_p90", "1", "Enables Tracers.", FCVAR_PLUGIN);
	bt_enableweapon_awp = CreateConVar("bt_enableweapon_awp", "1", "Enables Tracers.", FCVAR_PLUGIN);
	
	bt_trans = CreateConVar("bt_transition", "1", "Transitions the timescales if on. If not, timescales are set directly.", FCVAR_PLUGIN);
	bt_timescale = CreateConVar("bt_timescale", "0.50", "Slowdown timescale.", FCVAR_PLUGIN);
	bt_bomb_timescale = CreateConVar("bt_bomb_timescale", "0.20", "Slowdown timescale for Bombexplode.", FCVAR_PLUGIN);	
	bt_fsound = CreateConVar("bt_fsound", "2", "Plays a sound for the focus of bullet time. If 2 it replaces the default sound rather than playing simultaneously.", FCVAR_PLUGIN);
	HookEvent("player_death", EventPlayerDeath);	
	HookEvent("weapon_fire",Event_WeaponFire);
	HookEvent("bomb_exploded", Event_BombExplode);	
	HookConVarChange(bt_trans, OnConVarChanged_Trans);
	timescale = GetConVarFloat(bt_timescale);
	bomb_timescale = GetConVarFloat(bt_bomb_timescale);	
	transition = GetConVarBool(bt_trans);
	focussound = GetConVarBool(bt_fsound);
	Cheats = FindConVar("sv_cheats");
	
	g_CvarM249Life = CreateConVar("bt_laser_M249Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarM249Width = CreateConVar("bt_laser_M249Width", "2.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarP90Life = CreateConVar("bt_laser_P90Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarP90Width = CreateConVar("bt_laser_P90Width", "3.0", "Width of the Beam",FCVAR_PLUGIN);	
	g_CvarUSPLife = CreateConVar("bt_laser_USPLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarUSPWidth = CreateConVar("bt_laser_USPWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarGlockLife = CreateConVar("bt_laser_GlockLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarGlockWidth = CreateConVar("bt_laser_GlockWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarDeagleLife = CreateConVar("bt_laser_DeagleLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarDeagleWidth = CreateConVar("bt_laser_DeagleWidth", "2.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarXM1014Life = CreateConVar("bt_laser_XM1014Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarXM1014Width = CreateConVar("bt_laser_XM1014Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarM3Life = CreateConVar("bt_laser_M3Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarM3Width = CreateConVar("bt_laser_M3Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarP228Life = CreateConVar("bt_laser_P228Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarP228Width = CreateConVar("bt_laser_P228Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarMP5Life = CreateConVar("bt_laser_MP5Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarMP5Width = CreateConVar("bt_laser_MP5Width", "3.5", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarUMP45Life = CreateConVar("bt_laser_UMP45Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarUMP45Width = CreateConVar("bt_laser_UMP45Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarAWPLife = CreateConVar("bt_laser_AWPLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarAWPWidth = CreateConVar("bt_laser_AWPWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarSG550Life = CreateConVar("bt_laser_SG550Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarSG550Width = CreateConVar("bt_laser_SG550Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarScoutLife = CreateConVar("bt_laser_ScoutLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarScoutWidth = CreateConVar("bt_laser_ScoutWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarG3sg1Life = CreateConVar("bt_laser_G3sg1Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarG3sg1Width = CreateConVar("bt_laser_G3sg1Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarTMPLife= CreateConVar("bt_laser_TMPLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarTMPWidth = CreateConVar("bt_laser_TMPWidth", "3.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarMAC10Life = CreateConVar("bt_laser_MAC10Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarMAC10Width = CreateConVar("bt_laser_MAC10Width", "3.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarM4A1Life = CreateConVar("bt_laser_M4A1Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarM4A1Width = CreateConVar("bt_laser_M4A1Width", "3.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarAK47Life = CreateConVar("bt_laser_AK47Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarAK47Width = CreateConVar("bt_laser_AK47Width", "1.5", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarEliteLife = CreateConVar("bt_laser_EliteLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarEliteWidth = CreateConVar("bt_laser_EliteWidth", "1.5", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarFivesevenLife = CreateConVar("bt_laser_FivesevenLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarFivesevenWidth = CreateConVar("bt_laser_FivesevenWidth", "1.5", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarSG552Life = CreateConVar("bt_laser_SG552Life", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarSG552Width = CreateConVar("bt_laser_SG552Width", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarFamasLife = CreateConVar("bt_laser_FamasLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarFamasWidth = CreateConVar("bt_laser_FamasWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarAUGLife = CreateConVar("bt_laser_AUGLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarAUGWidth = CreateConVar("bt_laser_AUGWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	g_CvarGalilLife = CreateConVar("bt_laser_GalilLife", "0.5", "Life of the Beam",FCVAR_PLUGIN);
	g_CvarGalilWidth = CreateConVar("bt_laser_GalilWidth", "1.0", "Width of the Beam",FCVAR_PLUGIN);
	
	g_CvarTeam2Red = CreateConVar("bt_laser_team2_red", "25", "Amount OF Red In The Beam of Team2", FCVAR_NOTIFY);
	g_CvarTeam2Green = CreateConVar("bt_laser_team2_green", "25", "Amount Of Green In The Beam of Team2", FCVAR_NOTIFY);
	g_CvarTeam2Blue = CreateConVar("bt_laser_team2_blue", "200", "Amount OF Blue In The Beam of Team2", FCVAR_NOTIFY);
	g_CvarTeam3Red = CreateConVar("bt_laser_team3_red", "200", "Amount OF Red In The Beam of Team3", FCVAR_NOTIFY);
	g_CvarTeam3Green = CreateConVar("bt_laser_team3_green", "25", "Amount Of Green In The Beam of Team3", FCVAR_NOTIFY);
	g_CvarTeam3Blue = CreateConVar("bt_laser_team3_blue", "25", "Amount OF Blue In The Beam of Team3", FCVAR_NOTIFY);	
	g_CvarTrans = CreateConVar("bt_laser_alpha", "150", "Amount OF Transparency In Beam", FCVAR_NOTIFY);	
	
	AutoExecConfig(true,"sm_bullettime", "sm_bullettime");	
}

public OnConfigsExecuted() 
{
    AddFileToDownloadsTable("materials/imgay/slowdown1.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown2.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown3.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown1.vtf");
    AddFileToDownloadsTable("materials/imgay/slowdown2.vtf");
    AddFileToDownloadsTable("materials/imgay/slowdown3.vtf");
}

public OnMapStart()
{
	g_BeamSprite [1]= PrecacheModel("materials/sprites/laser.vmt");
	g_BeamSprite [2]= PrecacheModel("materials/sprites/laserbeam.vmt");
	g_BeamSprite [3]= PrecacheModel("materials/sprites/animglow02.vmt");
	g_BeamSprite [4]= PrecacheModel("materials/sprites/bluelight1.vmt");
	g_BeamSprite [5]= PrecacheModel("materials/sprites/crystal_beam1.vmt");
	g_BeamSprite [6]= PrecacheModel("materials/sprites/glow04.vmt");
	g_BeamSprite [7]= PrecacheModel("materials/sprites/lgtning.vmt");
	g_BeamSprite [8]= PrecacheModel("materials/sprites/physbeam.vmt");
	g_BeamSprite [9]= PrecacheModel("materials/sprites/physcannon_blueflare1.vmt");
	g_BeamSprite [10]= PrecacheModel("materials/sprites/bluelaser1.vmt");
	g_BeamSprite [11]= PrecacheModel("materials/sprites/combineball_trail_red_1.vmt");
	g_BeamSprite [12]= PrecacheModel("materials/sprites/orangelight1.vmt");
	g_BeamSprite [13]= PrecacheModel("materials/sprites/purplelaser1.vmt");
	g_BeamSprite [14]= PrecacheModel("materials/sprites/xbeam2.vmt");
	g_BeamSprite [15]= PrecacheModel("materials/sprites/lamphalo.vmt");
	g_BeamSprite [16]= PrecacheModel("materials/sprites/light_glow01.vmt");
	g_BeamSprite [17]= PrecacheModel("materials/sprites/redglow2.vmt");
	g_BeamSprite [18]= PrecacheModel("materials/sprites/splodesprite.vmt");
	g_BeamSprite [19]= PrecacheModel("materials/effects/gunshiptracer.vmt");
	
	PrecacheSound("mb_bullettime/enter.mp3", true);
	PrecacheSound("mb_bullettime/exit.mp3", true);
	AddFileToDownloadsTable("sound/mb_bullettime/enter.mp3");
	AddFileToDownloadsTable("sound/mb_bullettime/exit.mp3");	
	
	CheatConVarSetup()
}

public OnClientPostAdminCheck(client)
{
	if(IsValidClient(client))
		g_killCount[client] = 0;
}

ActivateSlow(activator) 
{
    if (slowdown > 0 || !GetConVarBool(bt_enable))
        return;
    slowdown = 55;
    for(new i = 1; i <= MaxClients; i++) 
	{
        if(IsValidClient(i) && !IsFakeClient(i)) 
		{
            ClientCommand(i,"r_screenoverlay imgay/slowdown1");
            if (i != activator) 
			{
                EmitSoundToClient(i, "mb_bullettime/enter.mp3");
            }
        }
    }
    timescale = GetConVarFloat(bt_timescale);
    ServerCommand("host_timescale %f", timescale);
}

ActivateBombSlowDown(activator) 
{
    if (slowdown > 0 || !GetConVarBool(bt_enable))
        return;
    slowdown = 55;
    for(new i = 1; i <= MaxClients; i++) 
	{
        if(IsValidClient(i) && !IsFakeClient(i)) 
		{
            ClientCommand(i,"r_screenoverlay imgay/slowdown1");
            if (i != activator) 
			{
                EmitSoundToClient(i, "mb_bullettime/enter.mp3");
            }
        }
    }
    bomb_timescale = GetConVarFloat(bt_bomb_timescale);
    ServerCommand("host_timescale %f", bomb_timescale);
}

public OnGameFrame() 
{
	if (transition && slowdown <= 10 && slowdown > 1)
	{
		timescale = GetConVarFloat(bt_timescale);
		new Float:difscale = 1.0 - timescale;
		new Float:tempscale = 1.0 - difscale * slowdown *0.1;
		ServerCommand("host_timescale %f", tempscale);
	}
	
	if (slowdown == 30)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && !IsFakeClient(i)) 
			{
				EmitSoundToClient(i, "mb_bullettime/exit.mp3");
			}
		}   
	}	

	if (slowdown == 5)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && !IsFakeClient(i)) 
			{
				ClientCommand(i,"r_screenoverlay imgay/slowdown2");
			}
		}   
	}
    
	if (slowdown == 3)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && !IsFakeClient(i))
			{
				ClientCommand(i,"r_screenoverlay imgay/slowdown3");
			}
		}   
	}
	if (slowdown == 1)
	{
		slowdown = slowdown - 1;
		ServerCommand("host_timescale 1.0")
		SetConVarInt(Cheats, 0, true, true)
		for(new i = 1; i <= MaxClients; i++) 
		{
			if(IsValidClient(i) && !IsFakeClient(i)) 
			{
				ClientCommand(i,"r_screenoverlay \"\"")
			}
		}
	}
	if (slowdown > 1)
	{
		slowdown = slowdown - 1;
	}
}

public OnConVarChanged_Trans(Handle:convar, const String:oldValue[], const String:newValue[]) 
{
	transition = GetConVarBool(bt_trans);
}

public Action:Event_BombExplode(Handle:event, const String:name[], bool:dontBroadcast)
{
	new activator = -1;	
	
	if(GetConVarInt(bt_c4) == 1)
	{
		ActivateBombSlowDown(activator);
		SetConVarInt(Cheats, 1, true, true);
	}
}

public EventPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));	
	
	if(IsValidClient(client))
	{	
		g_killCount[client] = 0;
	}
}

public EventPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(bt_enable))
		return;
	
	decl String:weapon[512];
	GetEventString(event, "weapon", weapon, sizeof(weapon));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new bool:go = false;
	new activator = -1;
	
	g_killCount[attacker]++;	
	new curCount = g_killCount[attacker];
	
	for (new i = 0; i < sizeof(Weapons); i++) 
	{
		if (StrEqual(weapon,Weapons[i],false)) 
		{	
			go = true;
		}	
		
		focussound = GetConVarBool(bt_fsound);
		if (go == true && focussound >= 1) 
		{
			if(IsValidClient(attacker) && !IsFakeClient(attacker)) 
			{
				EmitSoundToClient(attacker, "mb_bullettime/enter.mp3");
				if (focussound >= 2) activator = attacker;
			}
			ActivateSlow(activator);
			SetConVarInt(Cheats, 1, true, true);
		}
    }	
	
	if(GetConVarInt(bt_grenade) == 1)
	{
		if(StrEqual(weapon,"hegrenade",false))
		{
			go = true;
		}	
		
		focussound = GetConVarBool(bt_fsound);
		if (go == true && focussound >= 1) 
		{
			if(IsValidClient(attacker) && !IsFakeClient(attacker)) 
			{
				EmitSoundToClient(attacker, "mb_bullettime/enter.mp3");
				if (focussound >= 2) activator = attacker;
			}
			ActivateSlow(activator);
			SetConVarInt(Cheats, 1, true, true);
		}
    }
	if(GetConVarInt(bt_kills_enabled) ==1 && IsValidClient(attacker))
	{
		if(curCount == GetConVarInt(bt_kills))
		{
			EmitSoundToClient(attacker, "mb_bullettime/enter.mp3");	
			ActivateSlow(activator);
			SetConVarInt(Cheats, 1, true, true);
		}
	}	
}

stock bool:IsValidClient(iClient)
{
    if (iClient <= 0) return false;
    if (iClient > MaxClients) return false;
    if (!IsClientConnected(iClient)) return false;
    return IsClientInGame(iClient);
}

public CheatConVarSetup()
{
	new flags = GetConVarFlags(Cheats) 
	flags &= ~FCVAR_NOTIFY
	SetConVarFlags(Cheats, flags)
	if(GetConVarInt(Cheats) == 1)
	{
		SetConVarInt(Cheats, 0, true, true)
	}
}

public Event_WeaponFire(Handle:event, const String:name[], bool:dontBroadcast)
{
	if( GetConVarInt(bt_enableweapontracers) )
	{
		new client;
		client = GetClientOfUserId(GetEventInt(event, "userid"));

		new Float:M249Life;
		M249Life = GetConVarFloat( g_CvarM249Life );
		new Float:M249Width;
		M249Width = GetConVarFloat( g_CvarM249Width );		
		
		new Float:P90Life;
		P90Life = GetConVarFloat( g_CvarP90Life );
		new Float:P90Width;
		P90Width = GetConVarFloat( g_CvarP90Width );		
		
		new Float:USPLife;
		USPLife = GetConVarFloat( g_CvarUSPLife );
		new Float:USPWidth;
		USPWidth = GetConVarFloat( g_CvarUSPWidth );
	
		new Float:P228Life;
		P228Life = GetConVarFloat( g_CvarP228Life );
		new Float:P228Width;
		P228Width = GetConVarFloat( g_CvarP228Width );
	
		new Float:GlockLife;
		GlockLife = GetConVarFloat( g_CvarGlockLife );
		new Float:GlockWidth;
		GlockWidth= GetConVarFloat( g_CvarGlockWidth );
	
		new Float:XM1014Life;
		XM1014Life = GetConVarFloat( g_CvarXM1014Life );
		new Float:XM1014Width;
		XM1014Width = GetConVarFloat( g_CvarXM1014Width );
	
		new Float:M3Life;
		M3Life = GetConVarFloat( g_CvarM3Life );
		new Float:M3Width;
		M3Width = GetConVarFloat( g_CvarM3Width );
	
		new Float:DeagleLife;
		DeagleLife = GetConVarFloat( g_CvarDeagleLife );
		new Float:DeagleWidth;
		DeagleWidth = GetConVarFloat( g_CvarDeagleWidth );
	
		new Float:MP5Life;
		MP5Life = GetConVarFloat( g_CvarMP5Life );
		new Float:MP5Width ;
		MP5Width  = GetConVarFloat( g_CvarMP5Width );
	
		new Float:UMP45Life;
		UMP45Life = GetConVarFloat( g_CvarUMP45Life );
		new Float:UMP45Width ;
		UMP45Width  = GetConVarFloat( g_CvarUMP45Width );
	
		new Float:AWPLife;
		AWPLife = GetConVarFloat( g_CvarAWPLife );
		new Float:AWPWidth;
		AWPWidth = GetConVarFloat( g_CvarAWPWidth );
	
		new Float:ScoutLife;
		ScoutLife = GetConVarFloat( g_CvarScoutLife );
		new Float:ScoutWidth;
		ScoutWidth = GetConVarFloat( g_CvarScoutWidth );
	
		new Float:SG550Life;
		SG550Life = GetConVarFloat( g_CvarSG550Life );
		new Float:SG550Width ;
		SG550Width  = GetConVarFloat( g_CvarSG550Width );
	
		new Float:G3sg1Life;
		G3sg1Life = GetConVarFloat( g_CvarG3sg1Life );
		new Float:G3sg1Width ;
		G3sg1Width  = GetConVarFloat( g_CvarG3sg1Width );
	
		new Float:TMPLife;
		TMPLife = GetConVarFloat( g_CvarTMPLife );
		new Float:TMPWidth;
		TMPWidth = GetConVarFloat( g_CvarTMPWidth );
	
		new Float:MAC10Life;
		MAC10Life = GetConVarFloat( g_CvarMAC10Life );
		new Float:MAC10Width;
		MAC10Width = GetConVarFloat( g_CvarMAC10Width );
	
		new Float:M4A1Life;
		M4A1Life = GetConVarFloat( g_CvarM4A1Life );
		new Float:M4A1Width;
		M4A1Width = GetConVarFloat( g_CvarM4A1Width );
	
		new Float:EliteLife;
		EliteLife = GetConVarFloat( g_CvarEliteLife );
		new Float:EliteWidth;
		EliteWidth = GetConVarFloat( g_CvarEliteWidth );
	
		new Float:AK47Life;
		AK47Life = GetConVarFloat( g_CvarAK47Life );
		new Float:AK47Width ;
		AK47Width  = GetConVarFloat( g_CvarAK47Width );
	
		new Float:FivesevenLife;
		FivesevenLife = GetConVarFloat( g_CvarFivesevenLife );
		new Float:FivesevenWidth ;
		FivesevenWidth  = GetConVarFloat( g_CvarFivesevenWidth );
	
		new Float:SG552Life;
		SG552Life = GetConVarFloat( g_CvarSG552Life );
		new Float:SG552Width;
		SG552Width = GetConVarFloat( g_CvarSG552Width );
	
		new Float:AUGLife;
		AUGLife = GetConVarFloat( g_CvarAUGLife );
		new Float:AUGWidth;
		AUGWidth = GetConVarFloat( g_CvarAUGWidth );
	
		new Float:FamasLife;
		FamasLife = GetConVarFloat( g_CvarFamasLife );
		new Float:FamasWidth;
		FamasWidth = GetConVarFloat( g_CvarFamasWidth );
		
		new Float:GalilLife;
		GalilLife = GetConVarFloat( g_CvarGalilLife );
		new Float:GalilWidth;
		GalilWidth = GetConVarFloat( g_CvarGalilWidth );
		
	
		decl Float:vecOrigin[3], Float:vecAng[3], Float:vecPos[3];
		GetClientEyePosition(client, vecOrigin);
		GetClientEyeAngles(client, vecAng);
		new Handle:trace = TR_TraceRayFilterEx(vecOrigin, vecAng, MASK_SHOT_HULL, RayType_Infinite, TraceEntityFilterPlayer);	
	
		new String:sWeapon[32];
		GetClientWeapon(client,sWeapon, sizeof(sWeapon));
	
		if(TR_DidHit(trace))
		{
			if(StrEqual ("weapon_m249" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_m249))
				{
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );					
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[1], 0, 0, 0, M249Life, M249Width, M249Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
			
			if(StrEqual ("weapon_p90" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_p90))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[2], 0, 0, 0, P90Life, P90Width, P90Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}			
		
			if(StrEqual ("weapon_usp" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_usp))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[3], 0, 0, 0, USPLife, USPWidth, USPWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
			
			if(StrEqual ("weapon_glock" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_glock))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
				
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[4], 0, 0, 0, GlockLife, GlockWidth, GlockWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
		
			if(StrEqual ("weapon_deagle" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_deagle))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[5], 0, 0, 0, DeagleLife, DeagleWidth, DeagleWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
		
			if(StrEqual ("weapon_xm1014" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_xm1014))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[6], 0, 0, 0, XM1014Life, XM1014Width, XM1014Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
	
			if(StrEqual ("weapon_p228" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_p228))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[7], 0, 0, 0, P228Life, P228Width, P228Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
	
			if(StrEqual ("weapon_mp5navy" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_mp5navy))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[8], 0, 0, 0, MP5Life, MP5Width, MP5Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
			
			if(StrEqual ("weapon_awp" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_awp))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[9], 0, 0, 0, AWPLife, AWPWidth, AWPWidth, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
			
			if(StrEqual ("weapon_sg550" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_sg550))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[10], 0, 0, 0, SG550Life, SG550Width,SG550Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
			
			if(StrEqual ("weapon_tmp" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_tmp))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[11], 0, 0, 0, TMPLife, TMPWidth, TMPWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}
	
			if(StrEqual ("weapon_mac10" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_mac10))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[12], 0, 0, 0, MAC10Life, MAC10Width, MAC10Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
	
			if(StrEqual ("weapon_m4a1" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_m4a1))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[13], 0, 0, 0,M4A1Life, M4A1Width, M4A1Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}

			if(StrEqual ("weapon_ak47" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_ak47))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[14], 0, 0, 0, AK47Life, AK47Width, AK47Width ,1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}

			if(StrEqual ("weapon_sg552" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_sg552))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[15], 0, 0, 0, SG552Life, SG552Width, SG552Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
	
			if(StrEqual ("weapon_famas" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_famas))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;	
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[16], 0, 0, 0, FamasLife, FamasWidth, FamasWidth, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}	
	
			if(StrEqual ("weapon_m3" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_m3))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[17], 0, 0, 0, M3Life, M3Width, M3Width, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}		
	
			if(StrEqual ("weapon_ump45" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_ump45))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[18], 0, 0, 0, UMP45Life, UMP45Width, UMP45Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}		
	
			if(StrEqual ("weapon_scout" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_scout))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[19], 0, 0, 0, ScoutLife, ScoutWidth, ScoutWidth, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}		
	
			if(StrEqual ("weapon_g3sg1" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_g3sg1))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[9], 0, 0, 0, G3sg1Life, G3sg1Width, G3sg1Width, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}		

			if(StrEqual ("weapon_aug" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_aug))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[5], 0, 0, 0, AUGLife, AUGWidth, AUGWidth, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}

			if(StrEqual ("weapon_galil" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_galil))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[19], 0, 0, 0, GalilLife, GalilWidth, GalilWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}		
	
			if(StrEqual ("weapon_fiveseven" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_fiveseven))
				{					
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[11], 0, 0, 0, FivesevenLife, FivesevenWidth, FivesevenWidth, 1, 0.0, color, 0);
					TE_SendToAll();
				}
			}		

			if(StrEqual ("weapon_elite" , sWeapon))
			{
				if( GetConVarInt(bt_enableweapon_elite))
				{				
					TR_GetEndPosition(vecPos, trace);
					vecOrigin[0] += 0;
					vecOrigin[1] -= 0;
					vecOrigin[2] -= 1;
					
					new color[4];
					if(GetClientTeam(client) == 2)
					{
						color[0] = GetConVarInt( g_CvarTeam2Red ); 
						color[1] = GetConVarInt( g_CvarTeam2Green );
						color[2] = GetConVarInt( g_CvarTeam2Blue );
					}
					else if(GetClientTeam(client) == 3)
					{
						color[0] = GetConVarInt( g_CvarTeam3Red ); 
						color[1] = GetConVarInt( g_CvarTeam3Green );
						color[2] = GetConVarInt( g_CvarTeam3Blue );
					}
					color[3] = GetConVarInt( g_CvarTrans );
			
					CloseHandle(trace);
		
					TE_SetupBeamPoints(vecOrigin, vecPos, g_BeamSprite[7], 0, 0, 0, EliteLife, EliteWidth, EliteWidth, 1, 0.0, color, 0);
					TE_SendToAll();	
				}
			}
		}
	}
}


public bool:TraceEntityFilterPlayer(entity, contentsMask, any:client) 
{
	return entity>MaxClients;
}